# coding: utf-8

"""

    # Authentication  <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 0.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from apifff.api_client import ApiClient


class OfficielCategorieApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_officiel_categorie_collection(self, **kwargs):  # noqa: E501
        """Retrieves the collection of OfficielCategorie resources.  # noqa: E501

        Retrieves the collection of OfficielCategorie resources.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_officiel_categorie_collection(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int page: The collection page number
        :param int sa_no:
        :param list[int] sa_no:
        :param str ca_cod:
        :param list[str] ca_cod:
        :param str ca_niv:
        :param list[str] ca_niv:
        :return: InlineResponse20018
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_officiel_categorie_collection_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_officiel_categorie_collection_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_officiel_categorie_collection_with_http_info(self, **kwargs):  # noqa: E501
        """Retrieves the collection of OfficielCategorie resources.  # noqa: E501

        Retrieves the collection of OfficielCategorie resources.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_officiel_categorie_collection_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int page: The collection page number
        :param int sa_no:
        :param list[int] sa_no:
        :param str ca_cod:
        :param list[str] ca_cod:
        :param str ca_niv:
        :param list[str] ca_niv:
        :return: InlineResponse20018
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['page', 'sa_no', 'sa_no', 'ca_cod', 'ca_cod', 'ca_niv', 'ca_niv']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_officiel_categorie_collection" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'sa_no' in params:
            query_params.append(('sa_no', params['sa_no']))  # noqa: E501
        if 'sa_no' in params:
            query_params.append(('sa_no[]', params['sa_no']))  # noqa: E501
            collection_formats['sa_no[]'] = 'multi'  # noqa: E501
        if 'ca_cod' in params:
            query_params.append(('ca_cod', params['ca_cod']))  # noqa: E501
        if 'ca_cod' in params:
            query_params.append(('ca_cod[]', params['ca_cod']))  # noqa: E501
            collection_formats['ca_cod[]'] = 'multi'  # noqa: E501
        if 'ca_niv' in params:
            query_params.append(('ca_niv', params['ca_niv']))  # noqa: E501
        if 'ca_niv' in params:
            query_params.append(('ca_niv[]', params['ca_niv']))  # noqa: E501
            collection_formats['ca_niv[]'] = 'multi'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/ld+json', 'application/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/officiel_categories', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20018',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_officiel_categorie_item(self, id, **kwargs):  # noqa: E501
        """Retrieves a OfficielCategorie resource.  # noqa: E501

        Retrieves a OfficielCategorie resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_officiel_categorie_item(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: Resource identifier (required)
        :return: OfficielCategorieJsonldOfficielCategorie
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_officiel_categorie_item_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_officiel_categorie_item_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def get_officiel_categorie_item_with_http_info(self, id, **kwargs):  # noqa: E501
        """Retrieves a OfficielCategorie resource.  # noqa: E501

        Retrieves a OfficielCategorie resource.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_officiel_categorie_item_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: Resource identifier (required)
        :return: OfficielCategorieJsonldOfficielCategorie
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_officiel_categorie_item" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_officiel_categorie_item`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/ld+json', 'application/json', 'text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/officiel_categories/{id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='OfficielCategorieJsonldOfficielCategorie',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
